// Agent auctioneer in project auction_ag

/* Initial beliefs and rules */

/* Initial goals */
!start.
/* Plans */

+!start <- .broadcast(tell, auction(service, flight_ticket(paris, athens,"15/12/2016"))).

+bid(Service, _)     // receives bids and checks for new winner
       :  .findall(b(V,A),bid(Service,V)[source(A)],L) & .length(L,4)
       <- .min(L,b(V,W));
          .print("Winner for ", Service, " is ",W," with ", V);
          .broadcast(tell, winner(Service,W)).

{ include("$jacamoJar/templates/common-cartago.asl") }
{ include("$jacamoJar/templates/common-moise.asl") }

// uncomment the include below to have a agent that always complies with its organization
//{ include("$jacamoJar/templates/org-obedient.asl") }
