// Agent auctioneer in project auction_ag

/* Initial beliefs and rules */

/* Initial goals */
!start.
/* Plans */

+!start : true <-
       !!cfp(flight_ticket(paris, athens,"15/12/2016"),"now + 10 seconds");
       !cfp(flight_ticket(athens, paris,"18/12/2016"),"now + 12 seconds").

       //.broadcast(tell, auction(service, flight_ticket(paris, athens,"15/12/2016")));
       //.broadcast(tell, auction(service, flight_ticket(athens, paris,"18/12/2016")));
       //.at("now + 10 seconds", {+!decide(flight_ticket(paris,athens,"15/12/2016"))});
       //.at("now + 12 seconds", {+!decide(flight_ticket(athens,paris,"18/12/2016"))}).

+!cfp(Service, Time) : true <-
       .broadcast(tell, auction(service, Service));
       .at(Time, {+!decide(Service)}).

+!decide(Service)     // receives bids and checks for new winner
       :  .findall(b(V,A),bid(Service,V)[source(A)],L)
       <- .min(L,b(V,W));
          .print("Winner for ", Service, " is ",W," with ", V, ". Options=",L);
          .broadcast(tell, winner(Service,W)).

{ include("$jacamoJar/templates/common-cartago.asl") }
{ include("$jacamoJar/templates/common-moise.asl") }

// uncomment the include below to have a agent that always complies with its organization
//{ include("$jacamoJar/templates/org-obedient.asl") }
